<div class="app-container">
    <div class="app-header">
        <mat-icon (click)="goToAngularPage()">keyboard_backspace</mat-icon>
        <h1>Form</h1>
    </div>
    <div class="app-content">
        <div>
            <form [formGroup]="studentForm" (ngSubmit)="submitStudentForm()">
                <div formGroupName="studentId">
                    <mat-form-field>
                        <mat-label>Username</mat-label>
                        <input type="text" matInput formControlName="username" placeholder="Ex. Logesh">
                        <mat-error *ngIf="!username?.valid && username?.touched">Username is invalid</mat-error>
                    </mat-form-field>
                    <div *ngIf="!username?.valid && username?.touched">
                        <p *ngIf="username.errors?.usernameExist">Username is already used by other user</p>
                        <p *ngIf="username.errors?.required">Username is required</p>
                    </div>
        
                    <mat-form-field>
                        <mat-label>Email</mat-label>
                        <input type="text" matInput formControlName="email" placeholder="Ex. logesh@gmail.com">
                        <mat-error *ngIf="!email?.valid && email?.touched">Email is invalid</mat-error>
                    </mat-form-field>
                    <div *ngIf="!email?.valid && email?.touched">
                        <p *ngIf="email.errors?.emailExist">Email is already used by other user</p>
                        <p *ngIf="email.errors?.required">Email is required</p>
                    </div>
                </div>

                <mat-form-field>
                    <mat-label>Name</mat-label>
                    <input type="text" matInput formControlName="name" placeholder="Ex. Logesh">
                </mat-form-field>

                <mat-form-field>
                    <mat-label>Gender</mat-label>
                    <mat-select formControlName="gender">
                        <mat-option *ngFor="let gender of genders" [value]="gender.value">{{ gender.view }}</mat-option>
                    </mat-select>
                </mat-form-field>
                
                <div formArrayName="educationDetails">
                    <button mat-stroked-button color="accent" type="button" (click)="addEducationDetails()">Add Education</button>
                    <div *ngFor="let educationDetail of educationDetails.controls; let i = index">
                        <mat-form-field>
                            <mat-label>Education Details</mat-label>
                            <input type="text" matInput [formControlName]='i' placeholder="Ex. SSLC">
                        </mat-form-field>
                    </div>
                </div>
                <!-- [disabled]="!studentForm.valid" -->
                <button mat-raised-button color="primary" type="submit" >Submit Student Form</button>
                <button mat-raised-button color="primary" type="button" (click)="resetStudentForm()">Reset Student Form</button>
                <button mat-raised-button color="primary" type="button" (click)="setValue()">Set Value</button>
                <button mat-raised-button color="primary" type="button" (click)="patchValue()">Patch Value</button>
            </form>
        </div>
    </div>
</div>